From 824f8c35ef8d43c4bbfdc89ed068799e37079c9b Mon Sep 17 00:00:00 2001
From: Amitosh Swain Mahapatra <amitosh.swain@gmail.com>
Date: May 30 2018 07:00:27 +0000
Subject: [PATCH 1/4] Add type declarations to Http and Social providers


---

diff --git a/src/app/app.module.ts b/src/app/app.module.ts
index b5f9309..1378f59 100644
--- a/src/app/app.module.ts
+++ b/src/app/app.module.ts
@@ -18,8 +18,10 @@ import { SocialPage } from '../pages/social/social';
 import { WomenPage } from '../pages/women/women';
 
 import { Browser } from '../providers/browser/browser';
-import { Request } from '../providers/request/request';
+import { Http } from '../providers/http/http';
 import { IonicConfig } from '../providers/ionic-config/ionic-config';
+import { FacebookProvider } from '../providers/social/facebook';
+import { TwitterProvider } from '../providers/social/twitter';
 
 @NgModule({
   declarations: [
@@ -50,13 +52,15 @@ import { IonicConfig } from '../providers/ionic-config/ionic-config';
     Browser,
     IonicConfig,
     InAppBrowser,
-    Request,
+    Http,
     SocialSharing,
     SplashScreen,
     SpinnerDialog,
     StatusBar,
     Toast,
-    { provide: ErrorHandler, useClass: IonicErrorHandler }
+    FacebookProvider,
+    TwitterProvider,
+    { provide: ErrorHandler, useClass: IonicErrorHandler },
   ]
 })
 export class AppModule { }
diff --git a/src/pages/ask/ask.ts b/src/pages/ask/ask.ts
index 95433d0..7cf52af 100644
--- a/src/pages/ask/ask.ts
+++ b/src/pages/ask/ask.ts
@@ -2,7 +2,7 @@ import { Component } from '@angular/core';
 import { SocialSharing } from '@ionic-native/social-sharing';
 
 import { Browser } from '../../providers/browser/browser';
-import { AskFedora } from '../../providers/ask-fedora/ask-fedora';
+import { AskFedoraService } from '../../providers/ask-fedora/ask-fedora';
 
 /*
   Generated class for the AskPage page.
@@ -12,13 +12,13 @@ import { AskFedora } from '../../providers/ask-fedora/ask-fedora';
 */
 @Component({
   templateUrl: 'ask.html',
-  providers: [Browser, AskFedora],
+  providers: [Browser, AskFedoraService],
 })
 export class AskPage {
   private questions: any;
 
   constructor(private browser: Browser,
-    private askFedora: AskFedora, private socialSharing: SocialSharing) {
+    private askFedora: AskFedoraService, private socialSharing: SocialSharing) {
     this.questions = [];
   }
 
diff --git a/src/pages/social/social.ts b/src/pages/social/social.ts
index 7219971..0b30a6f 100644
--- a/src/pages/social/social.ts
+++ b/src/pages/social/social.ts
@@ -2,8 +2,9 @@ import { Component } from '@angular/core';
 import { SocialSharing } from '@ionic-native/social-sharing';
 
 import { Browser } from '../../providers/browser/browser';
-import { FB } from '../../providers/fb/fb';
-import { Tw } from '../../providers/tw/tw';
+import { FacebookProvider } from '../../providers/social/facebook';
+import { TwitterProvider } from '../../providers/social/twitter';
+import { Post } from '../../providers/social/social';
 
 /*
   Generated class for the SocialPage page.
@@ -13,18 +14,16 @@ import { Tw } from '../../providers/tw/tw';
 */
 @Component({
   templateUrl: 'social.html',
-  providers: [FB, Tw],
+  providers: [FacebookProvider, TwitterProvider],
 })
 export class SocialPage {
 
-  // TODO: Refactor, we are not supposed to use `any`, rather, ww should define an
-  // interface Post { content:string, date:Date }
-  private posts:Array<any>;
-  private tweets:Array<any>;
+  private posts:Post[];
+  private tweets:Post[];
   private updates:Array<any>;
   private USER:any;
 
-  constructor(private browser:Browser, private fb:FB, private tw:Tw,
+  constructor(private browser:Browser, private fb:FacebookProvider, private tw:TwitterProvider,
               private socialSharing:SocialSharing) {
     this.posts = [];
     this.tweets = [];
@@ -42,14 +41,14 @@ export class SocialPage {
 
   updateUpdates() {
     this.fb
-      .getPagePosts(this.USER.FB)
+      .getPosts(this.USER.FB)
       .then((posts:Array<any>) => {
         this.posts = posts;
         this.mergeUpdates();
       });
 
     this.tw
-      .getTimelineTweets(this.USER.TW)
+      .getPosts(this.USER.TW)
       .then((tweets:Array<any>) => {
         this.tweets = tweets;
         this.mergeUpdates();
diff --git a/src/providers/ask-fedora/ask-fedora.ts b/src/providers/ask-fedora/ask-fedora.ts
index 7929f70..f32e1cf 100644
--- a/src/providers/ask-fedora/ask-fedora.ts
+++ b/src/providers/ask-fedora/ask-fedora.ts
@@ -1,12 +1,23 @@
 import { Injectable } from '@angular/core';
 import 'rxjs/add/operator/map';
 
-import * as _ from 'lodash';
-
-import { Request } from '../request/request';
+import { Http } from '../http/http';
 
 const API_ENDPOINT = 'https://ask.fedoraproject.org/en/api/v1';
 
+export interface Question {
+  id: string,
+  title: string,
+  link: string,
+  answers: number,
+  content: string,
+  timestamp: Date,
+  tags: string[],
+  view: number,
+  vote: number,
+}
+
+
 /*
   Generated class for the AskFedora provider.
 
@@ -14,11 +25,11 @@ const API_ENDPOINT = 'https://ask.fedoraproject.org/en/api/v1';
   for more info on providers and Angular 2 DI.
 */
 @Injectable()
-export class AskFedora {
-  private API:any;
-  private questions:Array<any>;
+export class AskFedoraService {
+  private API: any;
+  private questions: Question[];
 
-  constructor(private request:Request) {
+  constructor(private request: Http) {
     this.API = {
       base: [API_ENDPOINT],
       questions: [API_ENDPOINT, 'questions'],
@@ -28,30 +39,29 @@ export class AskFedora {
   }
 
   getQuestions() {
-    if (!_.isEmpty(this.questions)) {
+    if (this.questions.length) {
       return Promise.resolve(this.questions);
     }
 
-    return new Promise((resolve, reject) => {
-      this.request.get(this.API.questions)
-        .then((data:any) => {
-          this.questions = _.map(data.questions, q => {
-            const question = {
-              id: q.id,
-              title: q.title,
-              link: q.url,
-              answers: q.answer_count,
-              content: q.summary,
-              timestamp: q.added_at,
-              tags:q.tags,
-              view:q.view_count,
-              vote:q.score,
-            };
-            return question;
-          });
-
-          return resolve(this.questions);
-        }).catch(reject);
-    });
+    return this.request.get(this.API.questions)
+      .toPromise()
+      .then((data: any) => {
+        this.questions = data.questions.map(q => {
+          const question = {
+            id: q.id,
+            title: q.title,
+            link: q.url,
+            answers: q.answer_count,
+            content: q.summary,
+            timestamp: q.added_at,
+            tags: q.tags,
+            view: q.view_count,
+            vote: q.score,
+          };
+          return question;
+        });
+
+        return this.questions;
+      });
   }
 }
diff --git a/src/providers/fedo-cal/fedo-cal.ts b/src/providers/fedo-cal/fedo-cal.ts
index 3a6288a..cfcc03d 100644
--- a/src/providers/fedo-cal/fedo-cal.ts
+++ b/src/providers/fedo-cal/fedo-cal.ts
@@ -4,7 +4,7 @@ import 'rxjs/add/operator/map';
 import * as _ from 'lodash';
 import * as moment from 'moment-timezone';
 
-import { Request } from '../request/request';
+import { Http } from '../http/http';
 
 const API_ENDPOINT = 'https://apps.fedoraproject.org/calendar/api/';
 const API = {
@@ -19,8 +19,8 @@ const TIME_FORMAT = 'h:mm a z';
 /*
   Convert title to capital case, but skip special names like FESCo, FAmSCo, i18n
 */
-function calendarNameToDisplayName(name:string) :string {
-  switch(name) {
+function calendarNameToDisplayName(name: string): string {
+  switch (name) {
     case 'i18n':
       return 'i18n';
     case 'fesco':
@@ -39,10 +39,10 @@ function calendarNameToDisplayName(name:string) :string {
 */
 @Injectable()
 export class FedoCal {
-  private calendars:any;
-  private meetings:any;
+  private calendars: any;
+  private meetings: any;
 
-  constructor(private request:Request) {
+  constructor(private request: Http) {
     this.calendars = [];
     this.meetings = [];
   }
@@ -52,21 +52,20 @@ export class FedoCal {
       return Promise.resolve(this.calendars);
     }
 
-    return new Promise((resolve, reject) => {
-      this.request.get(API.calendars)
-        .then((data:any) => {
-          this.calendars = _.map(data.calendars, c => {
-            return {
-              real_name: c.calendar_name,
-              display_name: calendarNameToDisplayName(c.calendar_name),
-              description: c.calendar_description,
-              contact: c.calendar_contact,
-            };
-          });
-
-          return resolve(this.calendars);
-        }).catch(reject);
-    });
+    return this.request.get(API.calendars)
+      .toPromise()
+      .then((data: any) => {
+        this.calendars = _.map(data.calendars, c => {
+          return {
+            real_name: c.calendar_name,
+            display_name: calendarNameToDisplayName(c.calendar_name),
+            description: c.calendar_description,
+            contact: c.calendar_contact,
+          };
+        });
+
+        return this.calendars
+      });
   }
 
   getMeetings(calendar) {
@@ -74,42 +73,41 @@ export class FedoCal {
       return Promise.resolve(this.meetings[calendar]);
     }
 
-    return new Promise((resolve, reject) => {
-      this.request.get(API.meetings, { calendar: calendar })
-        .then((data:any) => {
-          this.meetings[calendar] = _.map(data.meetings, m => {
-            const meeting:any = {
-              name: m.meeting_name,
-              real_description: m.meeting_information,
-              display_description: _.truncate(
-                m.meeting_information,
-                { length: 120, separator: ' ' }
-              ),
-              date_start: m.meeting_date,
-              time_start: m.meeting_time_start,
-              date_end: m.meeting_date_end,
-              time_end: m.meeting_time_end,
-              timezone: m.meeting_timezone,
-              location: m.meeting_location,
-            };
-
-            const start = dateToMoment(meeting.date_start, meeting.time_start, meeting.timezone);
-            meeting.moment_start = start;
-            meeting.datetime_start = start.toDate();
-
-            const end = dateToMoment(meeting.date_end, meeting.time_end, meeting.timezone);
-            meeting.moment_end = end;
-            meeting.datetime_end = end.toDate();
-
-            meeting.display_date = start.format(DATE_FORMAT);
-            meeting.display_time = start.format(TIME_FORMAT);
-
-            return meeting;
-          });
-
-          return resolve(this.meetings[calendar]);
-        }).catch(reject);
-    });
+    return this.request.get(API.meetings, { calendar: calendar })
+      .toPromise()
+      .then((data: any) => {
+        this.meetings[calendar] = _.map(data.meetings, m => {
+          const meeting: any = {
+            name: m.meeting_name,
+            real_description: m.meeting_information,
+            display_description: _.truncate(
+              m.meeting_information,
+              { length: 120, separator: ' ' }
+            ),
+            date_start: m.meeting_date,
+            time_start: m.meeting_time_start,
+            date_end: m.meeting_date_end,
+            time_end: m.meeting_time_end,
+            timezone: m.meeting_timezone,
+            location: m.meeting_location,
+          };
+
+          const start = dateToMoment(meeting.date_start, meeting.time_start, meeting.timezone);
+          meeting.moment_start = start;
+          meeting.datetime_start = start.toDate();
+
+          const end = dateToMoment(meeting.date_end, meeting.time_end, meeting.timezone);
+          meeting.moment_end = end;
+          meeting.datetime_end = end.toDate();
+
+          meeting.display_date = start.format(DATE_FORMAT);
+          meeting.display_time = start.format(TIME_FORMAT);
+
+          return meeting;
+        });
+
+        return this.meetings[calendar];
+      });
   }
 }
 
@@ -117,4 +115,4 @@ export class FedoCal {
 function dateToMoment(date, time, timezone) {
   return moment.tz(date + 'T' + time + 'Z', timezone).tz('Etc/UTC');
 }
- 
+
diff --git a/src/providers/fedora-mag/fedora-mag.ts b/src/providers/fedora-mag/fedora-mag.ts
index 196fc80..fa41391 100644
--- a/src/providers/fedora-mag/fedora-mag.ts
+++ b/src/providers/fedora-mag/fedora-mag.ts
@@ -3,13 +3,13 @@ import 'rxjs/add/operator/map';
 
 import * as _ from 'lodash';
 
-import { Request } from '../request/request';
+import { Http } from '../http/http';
 
 const API_ENDPOINT = 'https://fedoramagazine.org/wp-json/wp/v2';
 const API = {
   base: [API_ENDPOINT],
   posts: [API_ENDPOINT, 'posts'],
-//  media_url: [API_ENDPOINT, 'media'],
+  //  media_url: [API_ENDPOINT, 'media'],
 };
 
 /*
@@ -20,9 +20,9 @@ const API = {
 */
 @Injectable()
 export class FedoraMag {
-  private posts:any;
-  private media_url:any;
-  constructor(private request:Request) {
+  private posts: any;
+  private media_url: any;
+  constructor(private request: Http) {
     this.posts = [];
     this.media_url = [];
   }
@@ -32,53 +32,53 @@ export class FedoraMag {
       return Promise.resolve(this.posts);
     }
 
-    return new Promise((resolve, reject) => {
-      this.request.get(API.posts)
-        .then(data => {
-          this.posts = _.map(data, p => {
-            var excerpt = p.excerpt.rendered;
-            var post = {
-              id: p.id,
-              link: p.guid.rendered,
-              title: p.title.rendered,
-              image: p.featured_media,
-              excerpt: _.truncate(
-                _.truncate(excerpt, {
-                  length: excerpt.length,
-                  separator: '<a', omission: ''
-                }), { length: 150, separator: ' ' }
-              ),
-              content: p.content.rendered,
-              date: p.date_gmt,
-            };
-            //image_url = func_url(post.image);
-            return post;
-          });
+    return this.request.get(API.posts)
+      .toPromise()
+      .then(data => {
+        this.posts = _.map(data, p => {
+          var excerpt = p.excerpt.rendered;
+          var post = {
+            id: p.id,
+            link: p.guid.rendered,
+            title: p.title.rendered,
+            image: p.featured_media,
+            excerpt: _.truncate(
+              _.truncate(excerpt, {
+                length: excerpt.length,
+                separator: '<a', omission: ''
+              }), { length: 150, separator: ' ' }
+            ),
+            content: p.content.rendered,
+            date: p.date_gmt,
+          };
+          //image_url = func_url(post.image);
+          return post;
+        });
 
-          return resolve(this.posts);
-        }).catch(reject);
-    });
+        return this.posts;
+      });
   }
-/*  getMedia_url(posts) {
-    if (!_.isEmpty(this.media_url[posts])) {
-      return Promise.resolve(this.media_url[posts]);
-    }
 
-    return new Promise((resolve, reject) => {
-      this.request.get(this.API.media_url,{ posts : posts })
-        .then(data => {
-          this.media_url[posts] = _.map(data, i => {
-          //  var excerpt = p.excerpt.rendered;
-            var img_url = {
-              img_id: i.id,
-              img_link: i.guid.rendered,
-            };
-            //image_url = func_url(post.image);
-            return post;
-          });
+  /*  getMedia_url(posts) {
+      if (!_.isEmpty(this.media_url[posts])) {
+        return Promise.resolve(this.media_url[posts]);
+      }
+
+      return new Promise((resolve, reject) => {
+        this.request.get(this.API.media_url,{ posts : posts })
+          .then(data => {
+            this.media_url[posts] = _.map(data, i => {
+            //  var excerpt = p.excerpt.rendered;
+              var img_url = {
+                img_id: i.id,
+                img_link: i.guid.rendered,
+              };
+              //image_url = func_url(post.image);
+              return post;
+            });
 
-          return resolve(this.posts);
-        }).catch(reject);
-    });
-  }*/
+            return resolve(this.posts);
+          }).catch(reject);
+      });
+    }*/
 }
diff --git a/src/providers/http/http.ts b/src/providers/http/http.ts
new file mode 100644
index 0000000..f3f4402
--- /dev/null
+++ b/src/providers/http/http.ts
@@ -0,0 +1,129 @@
+import 'rxjs/add/operator/finally';
+import 'rxjs/add/operator/map';
+
+import { Injectable } from '@angular/core';
+import { HttpClient } from '@angular/common/http';
+import { SpinnerDialog } from '@ionic-native/spinner-dialog';
+import { Toast } from '@ionic-native/toast';
+import { IonicConfig } from '../ionic-config/ionic-config';
+
+import * as _ from 'lodash';
+import * as querystring from 'query-string';
+import { Observable } from 'rxjs/Observable';
+
+/*
+  Generated class for the Http provider.
+
+  See https://angular.io/docs/ts/latest/guide/dependency-injection.html
+  for more info on providers and Angular 2 DI.
+*/
+@Injectable()
+export class Http {
+  private proxies:any;
+  private isCordova:boolean;
+  private isLiveReload:boolean;
+
+  constructor(private httpClient:HttpClient, config:IonicConfig,
+    /* private spinnerDialog:SpinnerDialog, */ private toast:Toast) {
+    this.proxies = config.get('proxies');
+
+    this.isCordova = window.hasOwnProperty('cordova');
+    this.isLiveReload = false;
+
+    // this.http
+    //   .get('http://localhost:8100')
+    //   .subscribe(
+    //     res => this.isLiveReload = !_.isEmpty(res),
+    //     err => console.log(this.useProxy())
+    //   );
+  }
+
+  // private startHandler = () => {
+  //   this.spinnerDialog.show();
+  // }
+
+  // private stopHandler = () => {
+  //   this.spinnerDialog.hide();
+  // }
+
+  // private errorHandler = (error, reject) => {
+  //   this.toast.showShortBottom('Something went wrong.');
+  //   this.spinnerDialog.hide();
+  //   return reject(error);
+  // }
+
+  private useProxy() {
+    if (this.isLiveReload || !this.isCordova) {
+      return true;
+    } else {
+      return false;
+    }
+  }
+
+  private buildURL(parts:Array<string>):string {
+    return _.map(
+      parts, part => _.trim(part, '/')
+    ).join('/');
+  }
+
+  private processURL(urlParts) {
+    const url = this.buildURL(urlParts);
+
+    let finalURL = url;
+
+    if (this.useProxy()) {
+      this.proxies.forEach(proxy => {
+        if (url.startsWith(proxy.proxyUrl)) {
+          finalURL = _.replace(
+            url, proxy.proxyUrl, proxy.path
+          );
+          return false;
+        }
+      });
+
+      finalURL = _.trim(finalURL + '/');
+    }
+
+    return finalURL;
+  }
+
+  get<T>(urlParts, query?:any, headers = {}): Observable<T> {
+    let url = this.processURL(urlParts);
+
+    if (!_.isEmpty(query)) {
+      url = _.trimEnd(url, '/');
+      var query = querystring.stringify(query);
+      url += '?' + query;
+    }
+
+    // this.startHandler();
+    // return new Promise((resolve, reject) => {
+      return this.httpClient.get<T>(url, { headers });
+        // .subscribe(
+        //   response => resolve(response),
+        //   error => this.errorHandler.bind(this, error, reject),
+        //   this.stopHandler
+        // );
+    // });
+  }
+
+  post(urlParts, data = {}, headers = {}) {
+    const url = this.processURL(urlParts);
+    const body = JSON.stringify(data);
+
+    _.defaults(headers, {
+      'Content-Type': 'application/json'
+    });
+
+    // this.startHandler();
+    // return new Promise((resolve, reject) => {
+      return this.httpClient.post(url, body, { headers });
+        // .subscribe(
+        //   response => resolve(response),
+        //   error => this.errorHandler.bind(this, error, reject),
+        //   this.stopHandler
+        // );
+    // });
+  }
+}
+
diff --git a/src/providers/social/facebook.ts b/src/providers/social/facebook.ts
new file mode 100644
index 0000000..a5056e9
--- /dev/null
+++ b/src/providers/social/facebook.ts
@@ -0,0 +1,48 @@
+import { Injectable } from '@angular/core';
+import 'rxjs/add/operator/map';
+import ENV from '@environment';
+import { Facebook } from 'fb';
+import { compact } from 'lodash-es';
+import { SocialProvider, Post } from './social';
+
+/*
+  Generated class for the Fb provider.
+
+  See https://angular.io/docs/ts/latest/guide/dependency-injection.html
+  for more info on providers and Angular 2 DI.
+*/
+@Injectable()
+export class FacebookProvider implements SocialProvider {
+  private fb: Facebook;
+  constructor() {
+    this.fb = new Facebook(ENV.FB_CONFIG);
+  }
+
+  private api(uri) {
+    return new Promise((resolve, reject) => {
+      this.fb.api(uri, res => {
+        if (!res || res.error) {
+          return reject(res);
+        } else {
+          return resolve(res);
+        }
+      });
+    });
+  }
+
+  public async getPosts(page:string, args?): Promise<Post[]> {
+    const res:any = await this.api(`${page}/posts`);
+    const posts = compact<Post>(res.data.map(p => {
+          const post = {
+            id: p.id,
+            link: 'https://facebook.com/' + p.id,
+            content: p.message,
+            origin: 'facebook',
+          };
+
+          return post.content ? post : null;
+        }));
+
+        return posts;
+  }
+}
diff --git a/src/providers/social/social.ts b/src/providers/social/social.ts
new file mode 100644
index 0000000..b8d9482
--- /dev/null
+++ b/src/providers/social/social.ts
@@ -0,0 +1,18 @@
+
+export const FACEBOOK = 'facebook';
+export const TWITTER = 'twitter';
+
+export interface Post {
+  id:string,
+  origin:string,
+  link:string,
+  // date: Date,
+}
+
+export interface GetPostExtraArgs {
+  offset?: string,
+}
+
+export interface SocialProvider {
+  getPosts(resID: string, args?:GetPostExtraArgs): Promise<Post[]>
+}
diff --git a/src/providers/social/twitter.ts b/src/providers/social/twitter.ts
new file mode 100644
index 0000000..af1bd6b
--- /dev/null
+++ b/src/providers/social/twitter.ts
@@ -0,0 +1,47 @@
+import { Injectable } from '@angular/core';
+import 'rxjs/add/operator/map';
+import * as _ from 'lodash';
+
+import ENV from '@environment';
+
+import { Http } from '../http/http';
+import { SocialProvider, Post } from './social';
+
+
+const API_ENDPOINT = 'https://api.twitter.com/1.1/';
+
+const API: any = {
+  base: [API_ENDPOINT],
+  statuses: [API_ENDPOINT, 'statuses'],
+}
+API.timeline = API.statuses.concat(['user_timeline.json']);
+
+
+/*
+  Generated class for the Twitter provider.
+
+  See https://angular.io/docs/ts/latest/guide/dependency-injection.html
+  for more info on providers and Angular 2 DI.
+*/
+@Injectable()
+export class TwitterProvider implements SocialProvider {
+
+  constructor(private http: Http) { }
+
+  public async getPosts(handle:string, args?): Promise<Post[]> {
+    const response = (await this.http.get(
+      API.timeline, { screen_name: handle },
+      { 'Authorization': 'Bearer ' + ENV.TWITTER_CONFIG.BEARER_TOKEN }
+    ).toPromise() as any[]);
+
+    return response.map<Post>(t => {
+      return {
+        id: t.id,
+        link: 'https://twitter.com/statuses/' + t.id_str,
+        content: t.text,
+        origin: 'twitter',
+      };
+    });
+  }
+}
+
